import java.io.*;
import java.awt.image.*;
import javax.imageio.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.text.NumberFormat;
import java.text.DateFormat;
import java.sql.Time;
import jpos.*;
import jpos.events.*;

// SEWOO TECH POS PRINTER
import com.sewoo.thermal.jni.LKPOSTOT;
import com.sewoo.thermal.jni.LKPOSTOTConst;

public class Step3Frame extends JFrame {

	JPanel contentPane;
	JPanel jPanel_Receipt = new JPanel();
	TitledBorder titledBorder1;
	GridBagLayout gridBagLayout1 = new GridBagLayout();
	GridBagLayout gridBagLayout2 = new GridBagLayout();
	JButton jButton_Text = new JButton();
	JButton jButton_Close = new JButton();

	LKPOSTOT SWLib = null;

	/**Constract "Frame"*/
//	public Step3Frame() {
	public Step3Frame(LKPOSTOT sewoolib) {
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try {
			jbInit();
			pack();
			setVisible(true);
			SWLib = sewoolib;
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
	/**Form the conponent*/
	private void jbInit() throws Exception  {
		contentPane = (JPanel) this.getContentPane();
		titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(134, 134, 134)),"Receipt");
		contentPane.setLayout(gridBagLayout1);
		this.setSize(new Dimension(300, 300));
		this.setTitle("Step 3  Print Text");
		jPanel_Receipt.setLayout(gridBagLayout2);
		jPanel_Receipt.setBorder(titledBorder1);
		jButton_Text.setText("Print Text");
		jButton_Text.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			jButton_Text_actionPerformed(e);
			}
			});
		jButton_Close.setText("Close");
		jButton_Close.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			jButton_Close_actionPerformed(e);
			}
			});

		contentPane.add(jPanel_Receipt, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
			   ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(15, 0, 0, 0), 20, 20));

		jPanel_Receipt.add(jButton_Text, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
			 ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 10, 5, 10), 130, 0));

		contentPane.add(jButton_Close, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
		  ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(15, 0, 0, 0), 0, 0));
	}

	/**When the window was closed*/
	protected void processWindowEvent(WindowEvent e){
		super.processWindowEvent(e);
		if (e.getID() == WindowEvent.WINDOW_CLOSING){
			this.closing();
		}
		/**When the window was opened*/
		else if (e.getID() == WindowEvent.WINDOW_OPENED){
		}
	}

	void jButton_Text_actionPerformed(ActionEvent e) {
	        String ESC    = ((char) 0x1b) + "";
	        String LF     = ((char) 0x0a) + "";
	        String SPACES = "                                                                      ";

	        String BarData = "0123456789";

	        try {
	            do
	            {

		SWLib.PrintStart();
    
		SWLib.PrintText("Receipt\r\n\r\n\r\n", LKPOSTOTConst.LK_ALIGNMENT_CENTER, LKPOSTOTConst.LK_FNT_DEFAULT, LKPOSTOTConst.LK_TXT_2WIDTH);
		SWLib.PrintText("TEL (123)-456-7890\r\n", LKPOSTOTConst.LK_ALIGNMENT_RIGHT, LKPOSTOTConst.LK_FNT_DEFAULT, LKPOSTOTConst.LK_TXT_1WIDTH);
		SWLib.PrintText("Thank you for coming to our shop!\r\n", LKPOSTOTConst.LK_ALIGNMENT_CENTER, LKPOSTOTConst.LK_FNT_DEFAULT, LKPOSTOTConst.LK_TXT_1WIDTH);
		SWLib.PrintText("Chicken                             $10.00\r\n", LKPOSTOTConst.LK_ALIGNMENT_LEFT, LKPOSTOTConst.LK_FNT_DEFAULT, LKPOSTOTConst.LK_TXT_1WIDTH);
		SWLib.PrintText("Hamburger                           $20.00\r\n", LKPOSTOTConst.LK_ALIGNMENT_LEFT, LKPOSTOTConst.LK_FNT_DEFAULT, LKPOSTOTConst.LK_TXT_1WIDTH);
		SWLib.PrintText("Pizza                               $30.00\r\n", LKPOSTOTConst.LK_ALIGNMENT_LEFT, LKPOSTOTConst.LK_FNT_DEFAULT, LKPOSTOTConst.LK_TXT_1WIDTH);
		SWLib.PrintText("Lemons                              $40.00\r\n", LKPOSTOTConst.LK_ALIGNMENT_LEFT, LKPOSTOTConst.LK_FNT_DEFAULT, LKPOSTOTConst.LK_TXT_1WIDTH);
		SWLib.PrintText("Drink                               $50.00\r\n\r\n", LKPOSTOTConst.LK_ALIGNMENT_LEFT, LKPOSTOTConst.LK_FNT_DEFAULT, LKPOSTOTConst.LK_TXT_1WIDTH);
		SWLib.PrintText("Excluded tax                       $150.00\r\n", LKPOSTOTConst.LK_ALIGNMENT_LEFT, LKPOSTOTConst.LK_FNT_DEFAULT, LKPOSTOTConst.LK_TXT_1WIDTH);
		SWLib.PrintText("Tax(5%)                              $7.50\r\n", LKPOSTOTConst.LK_ALIGNMENT_LEFT, LKPOSTOTConst.LK_FNT_UNDERLINE, LKPOSTOTConst.LK_TXT_1WIDTH);
		SWLib.PrintText("Total         $157.50\r\n\r\n", LKPOSTOTConst.LK_ALIGNMENT_LEFT, LKPOSTOTConst.LK_FNT_DEFAULT, LKPOSTOTConst.LK_TXT_2WIDTH);
		SWLib.PrintText("Payment                            $200.00\r\n", LKPOSTOTConst.LK_ALIGNMENT_LEFT, LKPOSTOTConst.LK_FNT_DEFAULT, LKPOSTOTConst.LK_TXT_1WIDTH);
		SWLib.PrintText("Change                              $42.50\r\n\r\n", LKPOSTOTConst.LK_ALIGNMENT_LEFT, LKPOSTOTConst.LK_FNT_DEFAULT, LKPOSTOTConst.LK_TXT_1WIDTH);
		SWLib.PrintBarCode(BarData, LKPOSTOTConst.LK_BCS_Code39, 40, 512, LKPOSTOTConst.LK_ALIGNMENT_CENTER, LKPOSTOTConst.LK_HRI_TEXT_BELOW);
		// ̹ μ.
		String bitmapFile = "Logo.bmp";
		File imgFile = new File(bitmapFile);
		if( imgFile.exists() && imgFile.isFile() )
		{
			SWLib.PrintBitmap(bitmapFile, LKPOSTOTConst.LK_ALIGNMENT_CENTER, 0, 5, 0);
		}
		imgFile = null;

		SWLib.CutPaper();
    
		SWLib.PrintStop();
	            // exit our printing loop
	            } while (false);
	        }
	        catch(Exception ex)
	        {
			MessageBox.ok(ex.getMessage());
	        }
	        finally
	        {
	        }

	        return;
	}

	void jButton_Close_actionPerformed(ActionEvent e) {
		this.closing();
	}

	void closing()
	{
		dispose();
	}
}
