Attribute VB_Name = "Module1"
Option Explicit
 
' Method return value
Public Const LK_SUCCESS As Integer = 0
Public Const LK_CREATE_ERROR As Integer = 1
Public Const LK_NOT_OPENED As Integer = 2
Public Const LK_FAIL As Integer = -1

' Printer Status flag
Public Const LK_STS_NORMAL As Integer = 0
Public Const LK_STS_COVEROPEN As Integer = 1
Public Const LK_STS_PAPERNEAREMPTY As Integer = 2
Public Const LK_STS_PAPEREMPTY As Integer = 4
Public Const LK_STS_POWEROFF As Integer = 8

' Alignment Code
Public Const LK_ALIGNMENT_LEFT As Integer = 0
Public Const LK_ALIGNMENT_CENTER As Integer = 1
Public Const LK_ALIGNMENT_RIGHT As Integer = 2

' Bitmap Size
Public Const LK_BITMAP_NORMAL As Integer = 0
Public Const LK_BITMAP_WIDTH_DOUBLE As Integer = 1
Public Const LK_BITMAP_HEIGHT_DOUBLE As Integer = 2
Public Const LK_BITMAP_WIDTH_HEIGHT_DOUBLE As Integer = 3

' Bitmap Image Mode
Public Const LK_BITMAP_NO_DITHER As Integer = 0
Public Const LK_BITMAP_ERROR_DIFFUSION As Integer = 1
Public Const LK_BITMAP_ORDERED_DITHER As Integer = 2

'Text Attribute
'Font Attribute default value : not Bold, FontA, not Underline, not reverse
Public Const LK_FNT_DEFAULT As Integer = 0
Public Const LK_FNT_FONTB As Integer = 1
Public Const LK_FNT_BOLD As Integer = 8
Public Const LK_FNT_UNDERLINE As Integer = 128

' Text Size Attribute
Public Const LK_TXT_1WIDTH As Integer = 0
Public Const LK_TXT_2WIDTH As Integer = 16
Public Const LK_TXT_3WIDTH As Integer = 32
Public Const LK_TXT_4WIDTH As Integer = 48
Public Const LK_TXT_5WIDTH As Integer = 64
Public Const LK_TXT_6WIDTH As Integer = 80
Public Const LK_TXT_7WIDTH As Integer = 96
Public Const LK_TXT_8WIDTH As Integer = 112

Public Const LK_TXT_1HEIGHT As Integer = 0
Public Const LK_TXT_2HEIGHT As Integer = 1
Public Const LK_TXT_3HEIGHT As Integer = 2
Public Const LK_TXT_4HEIGHT As Integer = 3
Public Const LK_TXT_5HEIGHT As Integer = 4
Public Const LK_TXT_6HEIGHT As Integer = 5
Public Const LK_TXT_7HEIGHT As Integer = 6
Public Const LK_TXT_8HEIGHT As Integer = 7

' Barcode
Public Const LK_BCS_PDF417 As Integer = 200
Public Const LK_BCS_MAXICODE As Integer = 201
Public Const LK_BCS_QRCODE As Integer = 202
Public Const LK_BCS_DATAMATRIX As Integer = 203

Public Const LK_BCS_UPCA As Integer = 101
Public Const LK_BCS_UPCE As Integer = 102
Public Const LK_BCS_EAN8 As Integer = 103
Public Const LK_BCS_EAN13 As Integer = 104
Public Const LK_BCS_JAN8 As Integer = 105
Public Const LK_BCS_JAN13 As Integer = 106
Public Const LK_BCS_ITF As Integer = 107
Public Const LK_BCS_Codabar As Integer = 108
Public Const LK_BCS_Code39 As Integer = 109
Public Const LK_BCS_Code93 As Integer = 110
Public Const LK_BCS_Code128 As Integer = 111
Public Const LK_BCS_3OF5 As Integer = 112

' Barcode text position
Public Const LK_HRI_TEXT_NONE As Integer = 0
Public Const LK_HRI_TEXT_ABOVE As Integer = 1
Public Const LK_HRI_TEXT_BELOW As Integer = 2


' Cash Drawer Status
Public Const LK_CD_STS_CLOSED As Integer = 0
Public Const LK_CD_STS_OPENED As Integer = 1
    
' Cash Drawer Pin Connector
Public Const LK_CD_PIN_TWO As Integer = 2
Public Const LK_CD_PIN_FIVE As Integer = 5

' True-Type Font Style
Public Const LK_TTF_THIN     As Integer = 0
Public Const LK_TTF_NORMAL   As Integer = 1
Public Const LK_TTF_BOLD     As Integer = 2
Public Const LK_TTF_ITALIC       As Integer = &H10
Public Const LK_TTF_UNDERLINE    As Integer = &H20

' True-Type Font Reverse Print
Public Const LK_TTF_REVERSE_NO   As Integer = 0
Public Const LK_TTF_REVERSE_YES  As Integer = 1

' QRCode Error Correction Level.
Public Const LK_QRCODE_EC_LEVEL_L    As Integer = 0
Public Const LK_QRCODE_EC_LEVEL_M    As Integer = 1
Public Const LK_QRCODE_EC_LEVEL_Q    As Integer = 2
Public Const LK_QRCODE_EC_LEVEL_H    As Integer = 3

' QRCode mask pattern.
Public Const LK_QRCODE_MASK_AUTO As Integer = -1
Public Const LK_QRCODE_MASK_0    As Integer = 0
Public Const LK_QRCODE_MASK_1    As Integer = 1
Public Const LK_QRCODE_MASK_2    As Integer = 2
Public Const LK_QRCODE_MASK_3    As Integer = 3
Public Const LK_QRCODE_MASK_4    As Integer = 4
Public Const LK_QRCODE_MASK_5    As Integer = 5
Public Const LK_QRCODE_MASK_6    As Integer = 6
Public Const LK_QRCODE_MASK_7    As Integer = 7

' QRCode Symbol version.
Public Const LK_QRCODE_VERSION_00    As Integer = 0 ' Auto.
Public Const LK_QRCODE_VERSION_01    As Integer = 1 ' Version 1
Public Const LK_QRCODE_VERSION_02    As Integer = 2 ' Version 2
Public Const LK_QRCODE_VERSION_03    As Integer = 3 ' Version 3
Public Const LK_QRCODE_VERSION_04    As Integer = 4 ' Version 4
Public Const LK_QRCODE_VERSION_05    As Integer = 5 ' Version 5
Public Const LK_QRCODE_VERSION_06    As Integer = 6 ' Version 6
Public Const LK_QRCODE_VERSION_07    As Integer = 7 ' Version 7
Public Const LK_QRCODE_VERSION_08    As Integer = 8 ' Version 8
Public Const LK_QRCODE_VERSION_09    As Integer = 9 ' Version 9
Public Const LK_QRCODE_VERSION_10    As Integer = 10 ' Version 10
Public Const LK_QRCODE_VERSION_11    As Integer = 11 ' Version 11
Public Const LK_QRCODE_VERSION_12    As Integer = 12 ' Version 12
Public Const LK_QRCODE_VERSION_13    As Integer = 13 ' Version 13
Public Const LK_QRCODE_VERSION_14    As Integer = 14 ' Version 14
Public Const LK_QRCODE_VERSION_15    As Integer = 15 ' Version 15
Public Const LK_QRCODE_VERSION_16    As Integer = 16 ' Version 16
Public Const LK_QRCODE_VERSION_17    As Integer = 17 ' Version 17
Public Const LK_QRCODE_VERSION_18    As Integer = 18 ' Version 18
Public Const LK_QRCODE_VERSION_19    As Integer = 19 ' Version 19
Public Const LK_QRCODE_VERSION_20    As Integer = 20 ' Version 20
Public Const LK_QRCODE_VERSION_21    As Integer = 21 ' Version 21
Public Const LK_QRCODE_VERSION_22    As Integer = 22 ' Version 22
Public Const LK_QRCODE_VERSION_23    As Integer = 23 ' Version 23
Public Const LK_QRCODE_VERSION_24    As Integer = 24 ' Version 24
Public Const LK_QRCODE_VERSION_25    As Integer = 25 ' Version 25
Public Const LK_QRCODE_VERSION_26    As Integer = 26 ' Version 26
Public Const LK_QRCODE_VERSION_27    As Integer = 27 ' Version 27
Public Const LK_QRCODE_VERSION_28    As Integer = 28 ' Version 28
Public Const LK_QRCODE_VERSION_29    As Integer = 29 ' Version 29
Public Const LK_QRCODE_VERSION_30    As Integer = 30 ' Version 30
Public Const LK_QRCODE_VERSION_31    As Integer = 31 ' Version 31
Public Const LK_QRCODE_VERSION_32    As Integer = 32 ' Version 32
Public Const LK_QRCODE_VERSION_33    As Integer = 33 ' Version 33
Public Const LK_QRCODE_VERSION_34    As Integer = 34 ' Version 34
Public Const LK_QRCODE_VERSION_35    As Integer = 35 ' Version 35
Public Const LK_QRCODE_VERSION_36    As Integer = 36 ' Version 36
Public Const LK_QRCODE_VERSION_37    As Integer = 37 ' Version 37
Public Const LK_QRCODE_VERSION_38    As Integer = 38 ' Version 38
Public Const LK_QRCODE_VERSION_39    As Integer = 39 ' Version 39
Public Const LK_QRCODE_VERSION_40    As Integer = 40 ' Version 40
 
 
Public Declare Function OpenPort Lib "LKPOSTOT.dll" (ByVal PortName As String, ByVal BaudRate As Long) As Long
Public Declare Function ClosePort Lib "LKPOSTOT.dll" () As Long
Public Declare Function PrintBitmap Lib "LKPOSTOT.dll" (ByVal BitmapFile As String, _
    ByVal Alignment As Long, ByVal Options As Long, ByVal Brightness As Long, ByVal ImageMode As Long) As Long
Public Declare Function PrintString Lib "LKPOSTOT.dll" (ByVal Data As String) As Long
Public Declare Function PrintText Lib "LKPOSTOT.dll" (ByVal Data As String, _
    ByVal Alignment As Long, ByVal Options As Long, ByVal TextSize As Long) As Long
Public Declare Function PrintNormal Lib "LKPOSTOT.dll" (ByVal Data As String) As Long
Public Declare Function PrintBarCode Lib "LKPOSTOT.dll" (ByVal Data As String, _
    ByVal Symbology As Long, ByVal Height As Long, ByVal Width As Long, ByVal Alignment As Long, _
    ByVal TextPosition As Long) As Long
Public Declare Function PrinterSts Lib "LKPOSTOT.dll" () As Long
Public Declare Function OpenDrawer Lib "LKPOSTOT.dll" (ByVal DrawerPinNum As Long, _
    ByVal PulseOnTime As Long, ByVal PulseOffTime As Long) As Long
Public Declare Function DrawerSts Lib "LKPOSTOT.dll" () As Long
Public Declare Function CutPaper Lib "LKPOSTOT.dll" () As Long
Public Declare Function PrintStart Lib "LKPOSTOT.dll" () As Long
Public Declare Function PrintStop Lib "LKPOSTOT.dll" () As Long
Public Declare Function PrintData Lib "LKPOSTOT.dll" (ByVal Data As String, ByVal Size As Integer) As Long

Public Declare Function PrintQRCode Lib "LKPOSTOT.dll" (ByVal Data As String, ByVal Size As Long, ByVal ModuleSize As Long, _
    ByVal ECLevel As Long, ByVal Alignment As Long) As Long
Public Declare Function MakeQRCodeBitmap Lib "LKPOSTOT.dll" (ByVal Data As String, ByVal Size As Long, ByVal ModuleSize As Long, _
    ByVal ECLevel As Long, ByVal Version As Long, ByVal MaskPattern As Long, ByVal BitmapName As String) As Long
Public Declare Function PrintQRCodeGenerator Lib "LKPOSTOT.dll" (ByVal Data As String, ByVal Size As Long, ByVal ModuleSize As Long, _
    ByVal ECLevel As Long, ByVal Version As Long, ByVal MaskPattern As Long, ByVal Alignment As Long) As Long
Public Declare Function PrintQRCodeFromFile Lib "LKPOSTOT.dll" (ByVal File4QR As String, ByVal ModuleSize As Long, _
    ByVal ECLevel As Long, ByVal Version As Long, ByVal MaskPattern As Long, ByVal Alignment As Long) As Long


Public Declare Function PrintText2Image Lib "LKPOSTOT.dll" (ByVal FontName As String, ByVal FontStyle As Long, _
    ByVal FontDotSize As Long, ByVal TextData As String, ByVal PriReversePrinttY As Long) As Long
Public Declare Function PrintText2ImageAlignment Lib "LKPOSTOT.dll" (ByVal FontName As String, ByVal FontStyle As Long, _
    ByVal FontDotSize As Long, ByVal TextData As String, ByVal PriReversePrinttY As Long, ByVal Alignment As Long) As Long
Public Declare Function OutputCompletePrinting Lib "LKPOSTOT.dll" (ByVal TimeDelay As Long) As Long

Public Declare Function SetPageMode Lib "LKPOSTOT.dll" (ByVal IsPageMode As Boolean) As Long
Public Declare Function SetPrintDirection Lib "LKPOSTOT.dll" (ByVal pDirect As Integer) As Long
Public Declare Function SetPrintingArea Lib "LKPOSTOT.dll" (ByVal PageHeight As Integer) As Long
Public Declare Function SetAbsoluteVertical Lib "LKPOSTOT.dll" (ByVal AbsolutePosition As Integer) As Long
Public Declare Function SetRelativeVertical Lib "LKPOSTOT.dll" (ByVal RelativePosition As Integer) As Long
Public Declare Function PrintPDF417 Lib "LKPOSTOT.dll" (ByVal PdfData As String, ByVal DataLength As Long, ByVal NumberOfColumns As Long, _
    ByVal CellWidth As Long, ByVal Alignment As Long) As Long

Public Declare Function SaveNVBitmap Lib "LKPOSTOT.dll" (ByVal SaveBitmapNameList As String, _
    ByVal Brightness As Long, ByVal ImageMode As Long) As Long
Public Declare Function PrintNVBitmap Lib "LKPOSTOT.dll" (ByVal NVImageNumber As Long) As Long
Public Declare Function DeleteNVBitmap Lib "LKPOSTOT.dll" () As Long

Public Declare Function BlackMarkON Lib "LKPOSTOT.dll" (ByVal FeedValue As Long) As Long
Public Declare Function BlackMarkSearch Lib "LKPOSTOT.dll" () As Long

Public Declare Function LineFeed Lib "LKPOSTOT.dll" (ByVal LFCount As Long) As Long


Public Declare Function SetMasterUnit Lib "LKPOSTOT.dll" (ByVal UnitMeasure As Long) As Long
Public Declare Function PrintingWidth Lib "LKPOSTOT.dll" (ByVal pwidth As Long) As Long

Public Declare Function SetLabelSize Lib "LKPOSTOT.dll" (ByVal widthsize As Long, ByVal heightsize As Long) As Long
Public Declare Function PrintLabel Lib "LKPOSTOT.dll" () As Long
Public Declare Function PrintTTFXY Lib "LKPOSTOT.dll" (ByVal BaseUnitX As Long, ByVal BaseUnitY As Long, ByVal FontName As String, _
    ByVal FontStyle As Long, ByVal FontDotSize As Long, ByVal TextData As String, ByVal PriReversePrinttY As Long) As Long
Public Declare Function PrintBitmapXY Lib "LKPOSTOT.dll" (ByVal BaseUnitX As Long, ByVal BaseUnitY As Long, ByVal BitmapFile As String) As Long
Public Declare Function PrintQRCodeXY Lib "LKPOSTOT.dll" (ByVal BaseUnitX As Long, ByVal BaseUnitY As Long, ByVal Data As String, _
    ByVal Size As Long, ByVal ModuleSize As Long, ByVal ECLevel As Long, ByVal Version As Long, ByVal MaskPattern As Long) As Long
' with aligmnet.
Public Declare Function PrintTTFAlign Lib "LKPOSTOT.dll" (ByVal Alignment As Long, ByVal BaseUnitY As Long, ByVal FontName As String, _
    ByVal FontStyle As Long, ByVal FontDotSize As Long, ByVal TextData As String, ByVal PriReversePrinttY As Long) As Long
Public Declare Function PrintBitmapAlign Lib "LKPOSTOT.dll" (ByVal Alignment As Long, ByVal BaseUnitY As Long, ByVal BitmapFile As String) As Long
Public Declare Function PrintQRCodeAlign Lib "LKPOSTOT.dll" (ByVal Alignment As Long, ByVal BaseUnitY As Long, ByVal Data As String, _
    ByVal Size As Long, ByVal ModuleSize As Long, ByVal ECLevel As Long, ByVal Version As Long, ByVal MaskPattern As Long) As Long
' adjust to printiong position
Public Declare Function PrintTextLS Lib "LKPOSTOT.dll" (ByVal Data As String, ByVal Alignment As Long,
        ByVal Options As Long, ByVal TextSize As Long, ByVal LineSpacing As Long) As Long
Public Declare Function FeedDot Lib "LKPOSTOT.dll" (ByVal dotvalue As Long) As Long

' 1.40 added for powerbuilder application
Public Declare Function SetAlignment Lib "LKPOSTOT.dll" (ByVal Alignment As Long) As Long
Public Declare Function SetMagnify Lib "LKPOSTOT.dll" (ByVal WidthandHeight As Long) As Long
Public Declare Function SetAttribute Lib "LKPOSTOT.dll" (ByVal attr As Long) As Long

'1.59 added 
Public Declare Function SendCommand Lib "LKPOSTOT.dll" (ByVal Cmd As IntPtr, ByVal size As Long) As Long
Public Declare Function ReadData Lib "LKPOSTOT.dll" (ByVal ReadBuf As String, ByVal millisecond As Long) As Long
Public Declare Function SetEncoding Lib "LKPOSTOT.dll" (ByVal iEncoding As Long) As Long
Public Declare Function Rotation Lib "LKPOSTOT.dll" (ByVal pRotate As Long) As Long
Public Declare Function SetAbsoluteHorizontal Lib "LKPOSTOT.dll" (ByVal AbsolutePosition As Long) As Long
Public Declare Function SetMoveToXY Lib "LKPOSTOT.dll" (ByVal AbsoluteXPosition As Long, ByVal AbsoluteYPosition As Long) As Long
Public Declare Function GetFeedStatus Lib "LKPOSTOT.dll" () As Long


Public Function ByteArrayToString(ByteArray() As Byte) As String
    Dim sAns As String
    Dim iPos As String
    
    sAns = StrConv(ByteArray, vbUnicode)
    iPos = InStr(sAns, Chr(0))
    If iPos > 0 Then sAns = Left(sAns, iPos - 1)
    
    ByteArrayToString = sAns
 
 End Function
